import sys,time, wiringpi as pi

class acm1602:
    def __init__(self, i2c, ad ):
        self.ad = ad
        self.cursol = 1
        self.blink = 1
        self.display = 1
        self.x = 0
        self.y = 0
        
        self.so = i2c.setup( self.ad )
        
        time.sleep( 0.1 )
        self.send_data( i2c, 0x00, 0x01 )
        time.sleep( 0.15 )
        self.send_data( i2c, 0x00, 0x38 )
        time.sleep( 0.1 )
        self.send_data( i2c, 0x00, 0x0f )
        time.sleep( 0.1 )
        self.send_data( i2c, 0x00, 0x06 )
        time.sleep( 0.1 )
        
    def send_data( self, i2c, addr, data ):
        if ( i2c.writeReg8(self.so,addr,data) == -1 ):
            print("Error : Cannot send data to ACM1602.")
            print("Try re-connect Vdd for ACM1602.")
            sys.exit()

    def clear( self, i2c ):
        self.send_data( i2c, 0x00, 0x01 )
        time.sleep( 0.1 )

    def set_display( self, i2c ):
        buf = 0x08 + 0x04 * self.display + 0x02 * self.cursol + self.blink
        self.send_data( i2c, 0x00, buf)
        time.sleep(0.1)
        
    def set_cursol(self, i2c, buf):
        if buf != 0:
            buf = 1
        self.cursol = buf
        self.set_display( i2c )

    def set_blink(self, i2c, buf):
        if buf != 0:
            buf = 1
        self.blink = buf
        self.set_display( i2c )

    def move_home(self, i2c):
        self.x = 0
        self.y = 0
        self.send_data( i2c, 0x00, 0x02 )
        time.sleep(0.1)

    def move(self, i2c, mx, my):    
        self.x = mx
        self.y = my
        if self.x < 0:
            self.x=0
        if self.x > 0x0f:
            self.x=0x0f
        if self.y < 0:
            self.y=0
        if self.y > 1:
            self.y=1
        oy = self.y * 0x40
        out = self.x + oy + 0x80
        self.send_data( i2c, 0x00, out )
        time.sleep( 0.1 )

    def write(self, i2c, buf):
        length = len(buf)
        i = 0
        while i < length:
            if self.x > 0x0f:
                if self.y == 0:
                    self.move( 0x00, 0x01 )
                else:
                    break
            out = ord( buf[i] )
            self.send_data( i2c, 0x80, out)

            self.x = self.x + 1
            i = i + 1


