import time, wiringpi as pi
from acm1602 import acm1602

TRIG_PIN = 23
ECHO_PIN = 24

acm1602_addr = 0x50

pi.wiringPiSetupGpio()
i2c = pi.I2C()

acm1602 = acm1602( i2c, acm1602_addr )

pi.pinMode( TRIG_PIN, pi.OUTPUT )
pi.pinMode( ECHO_PIN, pi.INPUT )
pi.digitalWrite( TRIG_PIN, pi.LOW )
time.sleep( 1 )

def measure():
    pi.digitalWrite( TRIG_PIN, pi.HIGH )
    time.sleep(0.00001)
    pi.digitalWrite( TRIG_PIN, pi.LOW )
    while ( pi.digitalRead( ECHO_PIN ) == pi.LOW ):
        sigoff = time.time()
    while ( pi.digitalRead( ECHO_PIN ) == 1 ):
        sigon = time.time()
    return ( sigon - sigoff ) * 17000

acm1602.move_home( i2c )
acm1602.set_cursol( i2c, 0 )
acm1602.set_blink( i2c, 0 )

acm1602.move( i2c, 0, 0 )
acm1602.write( i2c, "Distance [cm]" )

while True:
    distance = str(measure())
    acm1602.move( i2c, 0, 1 )
    acm1602.write( i2c, distance )
    time.sleep(0.1)
